function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }
function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }
function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }
function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }
function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }
function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }
function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }
function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }
function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }
import "core-js/modules/es.object.freeze.js";
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.includes.js";
import "core-js/modules/es.string.includes.js";
import "core-js/modules/es.object.values.js";
import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/es.weak-map.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.weak-set.js";
import "core-js/modules/es.symbol.to-primitive.js";
import "core-js/modules/es.date.to-primitive.js";
import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.number.constructor.js";
import "core-js/modules/es.symbol.iterator.js";
import { warn } from "./helpers/console.mjs";
/**
 * Possible focus modes.
 * - CELL - The browser's focus stays on the lastly selected cell element.
 * - MIXED - The browser's focus switches from the lastly selected cell element to the currently active editor's
 * `TEXTAREA` element after a delay defined in the manager.
 *
 * @type {{CELL: string, MIXED: string}}
 */
var FOCUS_MODES = Object.freeze({
  CELL: 'cell',
  MIXED: 'mixed'
});

/**
 * Manages the browser's focus in the table.
 */
var _hot = /*#__PURE__*/new WeakMap();
var _focusMode = /*#__PURE__*/new WeakMap();
var _refocusDelay = /*#__PURE__*/new WeakMap();
var _refocusElementGetter = /*#__PURE__*/new WeakMap();
var _manageFocus = /*#__PURE__*/new WeakSet();
var _onUpdateSettings = /*#__PURE__*/new WeakSet();
export var FocusManager = /*#__PURE__*/function () {
  /**
   * The Handsontable instance.
   *
   * @private
   */

  /**
   * The currently enabled focus mode.
   * Can be either:
   *
   * - 'cell' - The browser's focus stays on the lastly selected cell element.
   * - 'mixed' - The browser's focus switches from the lastly selected cell element to the currently active editor's
   * `TEXTAREA` element after a delay defined in the manager.
   *
   * @type {string}
   * @private
   */

  /**
   * The delay after which the focus switches from the lastly selected cell to the active editor's `TEXTAREA`
   * element if the focus mode is set to 'mixed'.
   *
   * @type {number}
   * @private
   */

  /**
   * Getter function for the element to be used when refocusing the browser after a delay. If `null`, the active
   * editor's `TEXTAREA` element will be used.
   *
   * @type {null|Function}
   * @private
   */

  function FocusManager(hotInstance) {
    var _this = this;
    _classCallCheck(this, FocusManager);
    /**
     * Update the manager configuration after calling `updateSettings`.
     *
     * @private
     * @param {object} newSettings The new settings passed to the `updateSettings` method.
     */
    _classPrivateMethodInitSpec(this, _onUpdateSettings);
    /**
     * Manage the browser's focus after cell selection.
     *
     * @private
     */
    _classPrivateMethodInitSpec(this, _manageFocus);
    _classPrivateFieldInitSpec(this, _hot, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _focusMode, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _refocusDelay, {
      writable: true,
      value: 50
    });
    _classPrivateFieldInitSpec(this, _refocusElementGetter, {
      writable: true,
      value: null
    });
    var hotSettings = hotInstance.getSettings();
    _classPrivateFieldSet(this, _hot, hotInstance);
    _classPrivateFieldSet(this, _focusMode, hotSettings.imeFastEdit ? FOCUS_MODES.MIXED : FOCUS_MODES.CELL);
    _classPrivateFieldGet(this, _hot).addHook('afterUpdateSettings', function () {
      var _classPrivateMethodGe;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return (_classPrivateMethodGe = _classPrivateMethodGet(_this, _onUpdateSettings, _onUpdateSettings2)).call.apply(_classPrivateMethodGe, [_this].concat(args));
    });
    _classPrivateFieldGet(this, _hot).addHook('afterSelectionEnd', function () {
      var _classPrivateMethodGe2;
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      return (_classPrivateMethodGe2 = _classPrivateMethodGet(_this, _manageFocus, _manageFocus2)).call.apply(_classPrivateMethodGe2, [_this].concat(args));
    });
  }

  /**
   * Get the current focus mode.
   *
   * @returns {'cell' | 'mixed'}
   */
  _createClass(FocusManager, [{
    key: "getFocusMode",
    value: function getFocusMode() {
      return _classPrivateFieldGet(this, _focusMode);
    }

    /**
     * Set the focus mode.
     *
     * @param {'cell' | 'mixed'} focusMode The new focus mode.
     */
  }, {
    key: "setFocusMode",
    value: function setFocusMode(focusMode) {
      if (Object.values(FOCUS_MODES).includes(focusMode)) {
        _classPrivateFieldSet(this, _focusMode, focusMode);
      } else {
        warn("\"".concat(focusMode, "\" is not a valid focus mode."));
      }
    }

    /**
     * Get the delay after which the focus will change from the cell elements to the active editor's `TEXTAREA`
     * element if the focus mode is set to 'mixed'.
     *
     * @returns {number} Delay in milliseconds.
     */
  }, {
    key: "getRefocusDelay",
    value: function getRefocusDelay() {
      return _classPrivateFieldGet(this, _refocusDelay);
    }

    /**
     * Set the delay after which the focus will change from the cell elements to the active editor's `TEXTAREA`
     * element if the focus mode is set to 'mixed'.
     *
     * @param {number} delay Delay in milliseconds.
     */
  }, {
    key: "setRefocusDelay",
    value: function setRefocusDelay(delay) {
      _classPrivateFieldSet(this, _refocusDelay, delay);
    }

    /**
     * Set the function to be used as the "refocus element" getter. It should return a focusable HTML element.
     *
     * @param {Function} getRefocusElementFunction The refocus element getter.
     */
  }, {
    key: "setRefocusElementGetter",
    value: function setRefocusElementGetter(getRefocusElementFunction) {
      _classPrivateFieldSet(this, _refocusElementGetter, getRefocusElementFunction);
    }

    /**
     * Get the element to be used when refocusing the browser after a delay in case of the focus mode being 'mixed'.
     *
     * @returns {HTMLTextAreaElement|HTMLElement|undefined}
     */
  }, {
    key: "getRefocusElement",
    value: function getRefocusElement() {
      if (typeof _classPrivateFieldGet(this, _refocusElementGetter) === 'function') {
        return _classPrivateFieldGet(this, _refocusElementGetter).call(this);
      } else {
        var _classPrivateFieldGet2;
        return (_classPrivateFieldGet2 = _classPrivateFieldGet(this, _hot).getActiveEditor()) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.TEXTAREA;
      }
    }

    /**
     * Set the browser's focus to the highlighted cell of the last selection.
     */
  }, {
    key: "focusOnHighlightedCell",
    value: function focusOnHighlightedCell() {
      var _classPrivateFieldGet3;
      var lastSelectedRange = _classPrivateFieldGet(this, _hot).getSelectedRangeLast();
      var selectedCellCoords = lastSelectedRange.highlight;
      var selectedCell = _classPrivateFieldGet(this, _hot).getCell(selectedCellCoords.row, selectedCellCoords.col);
      if (selectedCell && !((_classPrivateFieldGet3 = _classPrivateFieldGet(this, _hot).getActiveEditor()) !== null && _classPrivateFieldGet3 !== void 0 && _classPrivateFieldGet3.isOpened())) {
        _classPrivateFieldGet(this, _hot).getCell(selectedCellCoords.row, selectedCellCoords.col).focus({
          preventScroll: true
        });
      }
    }

    /**
     * Set the focus to the active editor's `TEXTAREA` element after the provided delay. If no delay is provided, it
     * will be taken from the manager's configuration.
     *
     * @param {number} delay Delay in milliseconds.
     */
  }, {
    key: "refocusToEditorTextarea",
    value: function refocusToEditorTextarea() {
      var delay = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _classPrivateFieldGet(this, _refocusDelay);
      var refocusElement = this.getRefocusElement();

      // Re-focus on the editor's `TEXTAREA` element (or a predefined element) if the `imeFastEdit` option is enabled.
      if (_classPrivateFieldGet(this, _hot).getSettings().imeFastEdit && !!refocusElement) {
        _classPrivateFieldGet(this, _hot)._registerTimeout(function () {
          refocusElement.select();
        }, delay);
      }
    }
  }]);
  return FocusManager;
}();
function _manageFocus2() {
  this.focusOnHighlightedCell();
  if (this.getFocusMode() === FOCUS_MODES.MIXED) {
    this.refocusToEditorTextarea();
  }
}
function _onUpdateSettings2(newSettings) {
  if (newSettings.imeFastEdit && this.getFocusMode() !== FOCUS_MODES.MIXED) {
    this.setFocusMode(FOCUS_MODES.MIXED);
  } else if (!newSettings.imeFastEdit && this.getFocusMode() !== FOCUS_MODES.CELL) {
    this.setFocusMode(FOCUS_MODES.CELL);
  }
}